AliAnalysisTaskSELc2V0bachelorTMVA* AddTaskLc2V0bachpA_TMVA_KF_ON_OnlyHIJINGBkg(TString finname="Lc2V0bachelorCuts.root",
										  Bool_t theMCon=kTRUE,
										  Bool_t onTheFly=kFALSE){

  AliAnalysisManager *mgr = AliAnalysisManager::GetAnalysisManager();
  if (!mgr) {
    ::Error("AddTaskLc2V0bachelor", "No analysis manager to connect to.");
    return NULL;
  }  
  
  // cuts are stored in a TFile generated by makeTFile4CutsLc2V0bachelor.C in ./macros/
  // set there the cuts!!!!!

  Bool_t stdcuts=kFALSE;
  TFile* filecuts;
  if( finname.EqualTo("") ) {
    stdcuts=kTRUE; 
  } else {
    filecuts=TFile::Open(finname.Data());
    if(!filecuts ||(filecuts&& !filecuts->IsOpen())){
      AliFatal("Input file not found : check your cut object");
    }
  }

  AliRDHFCutsLctoV0* RDHFCutsLctoV0anal = new AliRDHFCutsLctoV0();
  if (stdcuts) RDHFCutsLctoV0anal->SetStandardCutsPP2010();
  else RDHFCutsLctoV0anal = (AliRDHFCutsLctoV0*)filecuts->Get("LctoV0AnalysisCuts");
  RDHFCutsLctoV0anal->SetName("LctoV0AnalysisCuts");
  RDHFCutsLctoV0anal->SetMinPtCandidate(-1.);
  RDHFCutsLctoV0anal->SetMaxPtCandidate(10000.);


  // mm let's see if everything is ok
  if (!RDHFCutsLctoV0anal) {
    cout << "Specific AliRDHFCutsLctoV0 not found\n";
    return;
  }


  //CREATE THE TASK

  printf("CREATE TASK\n");
  AliAnalysisTaskSELc2V0bachelorTMVA *task = new AliAnalysisTaskSELc2V0bachelorTMVA("AliAnalysisTaskSELc2V0bachelorTMVA", RDHFCutsLctoV0anal, onTheFly);
  task->SetIspA(kTRUE);
  task->SetMC(theMCon);
  task->SetK0sAnalysis(kTRUE);
  task->SetDebugLevel(0);
  task->SetCallKFVertexing(kTRUE);
  task->SetKeepingKeepingOnlyHIJINGBkg(kTRUE);
  mgr->AddTask(task);

  // Create and connect containers for input/output  
  TString outputfile = AliAnalysisManager::GetCommonFileName();
  outputfile += ":PWG3_D2H_Lc2pK0S";

  mgr->ConnectInput(task,0,mgr->GetCommonInputContainer());
  AliAnalysisDataContainer *coutput1   = mgr->CreateContainer(Form("treeList"),TList::Class(),AliAnalysisManager::kOutputContainer,"Lc2K0Sp_tree_pA.root"); // trees

  mgr->ConnectOutput(task, 1, coutput1);

  AliAnalysisDataContainer *coutputLc2 = mgr->CreateContainer(Form("Lc2pK0Scounter"),AliNormalizationCounter::Class(),AliAnalysisManager::kOutputContainer,"Lc2K0Sp_tree_pA.root"); //counter
  mgr->ConnectOutput(task, 2, coutputLc2);

  AliAnalysisDataContainer *coutputLc3 = mgr->CreateContainer(Form("Lc2pK0SCuts"),TList::Class(),AliAnalysisManager::kOutputContainer,"Lc2K0Sp_tree_pA.root"); // cuts
  mgr->ConnectOutput(task, 3, coutputLc3);

  AliAnalysisDataContainer *coutput4   = mgr->CreateContainer(Form("treeSgn"),TTree::Class(),AliAnalysisManager::kOutputContainer,"Lc2K0Sp_tree_pA.root"); // trees

  mgr->ConnectOutput(task, 4, coutput4);

  AliAnalysisDataContainer *coutput5   = mgr->CreateContainer(Form("treeBkg"),TTree::Class(),AliAnalysisManager::kOutputContainer,"Lc2K0Sp_tree_pA.root"); // trees

  mgr->ConnectOutput(task, 5, coutput5);

  AliAnalysisDataContainer *coutput6   = mgr->CreateContainer(Form("listHistoKF"), TList::Class(), AliAnalysisManager::kOutputContainer,"Lc2K0Sp_tree_pA.root"); // trees

  mgr->ConnectOutput(task, 6, coutput6);


  return task;

}
